Last Comment Bug 174688 - top border padding gets applied to block level next-in-flows
: top border padding gets applied to block level next-in-flows
Status: RESOLVED FIXED
: testcase
Product: Core
Classification: Components
Component: Layout: Block and Inline (show other bugs)
: Trunk
: x86 Windows 2000
: P3 normal (vote)
: Future
Assigned To: Robert O'Callahan (:roc) (Exited; email my personal email if necessary)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2002-10-15 21:19 PDT by karnaze (gone)
Modified: 2005-04-25 19:26 PDT (History)
1 user (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
printing test case from bug 127145 (528 bytes, text/html)
2002-10-15 21:20 PDT, karnaze (gone)
no flags Details
printing test case from bug 127145 (528 bytes, text/html)
2002-10-15 21:23 PDT, karnaze (gone)
no flags Details
fix (10.40 KB, patch)
2005-04-07 20:51 PDT, Robert O'Callahan (:roc) (Exited; email my personal email if necessary)
dbaron: review+
dbaron: superreview+
asa: approval1.8b2+
Details | Diff | Review

Description karnaze (gone) 2002-10-15 21:19:19 PDT
Kin discovered in bug 127145 that blocks/inlines do not consider whether a child
block level frame has a prev-in-flow when positioning the child using the top
border padding of the child (i.e. the top border padding is always used). There
are several places where this needs to be changed. It is unclear which places in
nsHTMLReflowState need to be changed, because if a change causes the computed
height for a next-in-flow to differ from the first-in-flow, some frame classes
are going to break (besides, if the computed height for a next-in-flow were to
differ it should differ in other ways than just the top border padding which is
getting a bit beyond the scope of what nsHTMLReflowState should be doing).
Comment 1 karnaze (gone) 2002-10-15 21:20:55 PDT
Created attachment 103022 [details]
printing test case from bug 127145
Comment 2 karnaze (gone) 2002-10-15 21:23:44 PDT
Created attachment 103023 [details]
printing test case from bug 127145

Its a shame I have to use IE to attach this file as html (m1.0 branch attaches
it as a gif).
Comment 3 Christian Reis 2002-10-21 13:40:08 PDT
Comment on attachment 103022 [details]
printing test case from bug 127145

yep, though you can change the mime type in the "edit attachment" page in
bugzilla.
Comment 4 Kevin McCluskey (gone) 2003-01-22 11:27:08 PST
Bulk setting karnaze's P2-P5 bugs to future
Comment 5 karnaze (gone) 2003-03-31 10:52:50 PST
mass reassign to default owner
Comment 6 Bernd 2004-09-11 11:21:55 PDT
this is a block issue the testcase does not use tables
Comment 7 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-04-07 20:51:21 PDT
Created attachment 180008 [details] [diff] [review]
fix

While working on bug 288560 I came up with a fix to this bug (174688). The fix
turned out to be unnecessary for 288560 but we might as well have it anyway.
The idea is just to have nsBlockReflowState::BorderPadding() compute the
borderpadding taking into account that continuations don't have top
borderpadding; nsHTMLReflowState::mComputedBorderPadding continues to have the
style borderpadding. I'm also changing the way non-auto-height blocks compute
their frame height to be more sane. In particular we need to ensure that if
such a frame is incomplete, it always grows to fill the available height,
otherwise we get funny looking gaps in the left/right borders at the bottom of
each column.
Comment 8 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-04-22 18:10:24 PDT
Comment on attachment 180008 [details] [diff] [review]
fix

r+sr=dbaron.  (Are there any problems with bottom border/padding?)
Comment 9 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-04-25 14:35:43 PDT
The bottom border and padding are OK; when we detect that the block is
incomplete, we already don't add them.
Comment 10 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-04-25 14:37:30 PDT
Comment on attachment 180008 [details] [diff] [review]
fix

This is a fix for printing and columns to make borders look better for
non-auto-height elements. It's very clearly only going to affect printing and
columns.
Comment 11 Asa Dotzler [:asa] 2005-04-25 16:43:31 PDT
Comment on attachment 180008 [details] [diff] [review]
fix

a=asa
Comment 12 Robert O'Callahan (:roc) (Exited; email my personal email if necessary) 2005-04-25 19:26:41 PDT
checked in

Note You need to log in before you can comment on or make changes to this bug.